(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                  projet Estime, INRIA-Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 2007-2011 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: my_data.mli,v 1.4.2.1 2011-09-21 13:08:04 fclement Exp $ *)

open Config;;
open Rdec2;;

type subdomain = {
  bd : boundary;
  err : float * float
};;

val get_bds : subdomain array -> boundary array;;
val get_errs : subdomain array -> (float * float) array;;
(** Extraction functions. *)

val set_bds : boundary array -> subdomain array -> unit;;
(** Insertion function. *)
