(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                  projet Estime, INRIA-Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 2007-2011 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: expor.ml,v 1.10.2.1 2011-09-21 13:08:03 fclement Exp $ *)

module A = Darray.A;;

type ('x, 'a, 'b) llexpr = int;;

let closures = A.create 16;;

let register f =
  let x = Obj.repr f in
  A.append closures x
;;

let retreive i =
  let x = A.get closures i in
  (Obj.magic x)
;;

let unsafe_retreive x = retreive x;;

let get_exportable (params, x) =
  let p = (Obj.repr params) in
  (p, x)
;;

type ('a, 'b) either = Right of 'a | Left of 'b;;

let is_registered f =
  let g a b =
    match a with
    | Right i -> Right i
    | Left i ->
      if b == (Obj.repr f)
      then Right i
      else Left (i + 1)
  in
  match A.fold_left g (Left 0) closures with
  | Left _ -> None
  | Right i -> Some i
;;
